diff --git a/TAGS b/TAGS
index b29badb..576a6d8 100644
--- a/TAGS
+++ b/TAGS
@@ -1791,59 +1796,58 @@ impl Cmd for ExitSearchMode {ExitSearchMode195,6137
     fn name(&self) -> &'static str {name196,6167
     fn execute(&self, _ctx: &CmdContext) -> Vec<Box<dyn Effect>> {execute199,6237
 
-src/command/cmd/mode.rs,3175
+src/command/cmd/mode.rs,3285
 mod tests {tests8,151
-    fn enter_edit_mode_produces_editing_mode() {enter_edit_mode_produces_editing_mode14,275
-    fn enter_tile_select_with_categories() {enter_tile_select_with_categories29,788
-    fn enter_tile_select_no_categories() {enter_tile_select_no_categories45,1285
-    fn enter_export_prompt_sets_mode() {enter_export_prompt_sets_mode56,1621
-    fn force_quit_always_produces_quit_mode() {force_quit_always_produces_quit_mode70,2055
-    fn save_and_quit_produces_save_then_quit() {save_and_quit_produces_save_then_quit83,2506
-    fn edit_or_drill_without_aggregation_enters_edit() {edit_or_drill_without_aggregation_enters_edit96,2993
-    fn enter_search_mode_sets_flag_and_clears_query() {enter_search_mode_sets_flag_and_clears_query107,3393
-pub struct EnterMode(pub AppMode);EnterMode129,4200
-impl Cmd for EnterMode {EnterMode130,4235
-    fn name(&self) -> &'static str {name131,4260
-    fn execute(&self, _ctx: &CmdContext) -> Vec<Box<dyn Effect>> {execute134,4324
-pub struct ForceQuit;ForceQuit149,4842
-impl Cmd for ForceQuit {ForceQuit150,4864
-    fn name(&self) -> &'static str {name151,4889
-    fn execute(&self, _ctx: &CmdContext) -> Vec<Box<dyn Effect>> {execute154,4953
-pub struct Quit;Quit161,5159
-impl Cmd for Quit {Quit162,5176
-    fn name(&self) -> &'static str {name163,5196
-    fn execute(&self, ctx: &CmdContext) -> Vec<Box<dyn Effect>> {execute166,5251
-pub struct SaveAndQuit;SaveAndQuit179,5597
-impl Cmd for SaveAndQuit {SaveAndQuit180,5621
-    fn name(&self) -> &'static str {name181,5648
-    fn execute(&self, _ctx: &CmdContext) -> Vec<Box<dyn Effect>> {execute184,5704
-pub struct EnterEditMode {EnterEditMode193,6114
-    pub initial_value: String,initial_value194,6141
-impl Cmd for EnterEditMode {EnterEditMode196,6174
-    fn name(&self) -> &'static str {name197,6203
-    fn execute(&self, ctx: &CmdContext) -> Vec<Box<dyn Effect>> {execute200,6272
-pub struct EditOrDrill;EditOrDrill220,6953
-impl Cmd for EditOrDrill {EditOrDrill221,6977
-    fn name(&self) -> &'static str {name222,7004
-    fn execute(&self, ctx: &CmdContext) -> Vec<Box<dyn Effect>> {execute225,7071
-pub struct EnterEditAtCursorCmd;EnterEditAtCursorCmd254,8262
-impl Cmd for EnterEditAtCursorCmd {EnterEditAtCursorCmd255,8295
-    fn name(&self) -> &'static str {name256,8331
-    fn execute(&self, _ctx: &CmdContext) -> Vec<Box<dyn Effect>> {execute259,8405
-pub struct EnterExportPrompt;EnterExportPrompt266,8578
-impl Cmd for EnterExportPrompt {EnterExportPrompt267,8608
-    fn name(&self) -> &'static str {name268,8641
-    fn execute(&self, _ctx: &CmdContext) -> Vec<Box<dyn Effect>> {execute271,8714
-pub struct EnterSearchMode;EnterSearchMode278,8890
-impl Cmd for EnterSearchMode {EnterSearchMode279,8918
-    fn name(&self) -> &'static str {name280,8949
-    fn execute(&self, _ctx: &CmdContext) -> Vec<Box<dyn Effect>> {execute283,9009
-pub struct EnterTileSelect;EnterTileSelect293,9266
-impl Cmd for EnterTileSelect {EnterTileSelect294,9294
-    fn name(&self) -> &'static str {name295,9325
-    fn execute(&self, ctx: &CmdContext) -> Vec<Box<dyn Effect>> {execute298,9396
+    fn enter_tile_select_with_categories() {enter_tile_select_with_categories14,275
+    fn enter_tile_select_no_categories() {enter_tile_select_no_categories30,772
+    fn enter_export_prompt_sets_mode() {enter_export_prompt_sets_mode41,1108
+    fn force_quit_always_produces_quit_mode() {force_quit_always_produces_quit_mode55,1542
+    fn save_and_quit_produces_save_then_quit() {save_and_quit_produces_save_then_quit68,1993
+    fn edit_or_drill_without_aggregation_enters_edit() {edit_or_drill_without_aggregation_enters_edit81,2480
+    fn edit_or_drill_passes_records_editing_mode_through() {edit_or_drill_passes_records_editing_mode_through101,3324
+    fn enter_edit_at_cursor_cmd_passes_target_mode_to_effect() {enter_edit_at_cursor_cmd_passes_target_mode_to_effect123,4197
+    fn edit_or_drill_pre_fills_edit_buffer_with_display_value() {edit_or_drill_pre_fills_edit_buffer_with_display_value143,4926
+    fn enter_search_mode_sets_flag_and_clears_query() {enter_search_mode_sets_flag_and_clears_query161,5554
+pub struct EnterMode(pub AppMode);EnterMode183,6361
+impl Cmd for EnterMode {EnterMode184,6396
+    fn name(&self) -> &'static str {name185,6421
+    fn execute(&self, _ctx: &CmdContext) -> Vec<Box<dyn Effect>> {execute188,6485
+pub struct ForceQuit;ForceQuit203,7003
+impl Cmd for ForceQuit {ForceQuit204,7025
+    fn name(&self) -> &'static str {name205,7050
+    fn execute(&self, _ctx: &CmdContext) -> Vec<Box<dyn Effect>> {execute208,7114
+pub struct Quit;Quit215,7320
+impl Cmd for Quit {Quit216,7337
+    fn name(&self) -> &'static str {name217,7357
+    fn execute(&self, ctx: &CmdContext) -> Vec<Box<dyn Effect>> {execute220,7412
+pub struct SaveAndQuit;SaveAndQuit233,7758
+impl Cmd for SaveAndQuit {SaveAndQuit234,7782
+    fn name(&self) -> &'static str {name235,7809
+    fn execute(&self, _ctx: &CmdContext) -> Vec<Box<dyn Effect>> {execute238,7865
+pub struct EditOrDrill {EditOrDrill254,8707
+    pub edit_mode: AppMode,edit_mode255,8732
+impl Cmd for EditOrDrill {EditOrDrill257,8762
+    fn name(&self) -> &'static str {name258,8789
+    fn execute(&self, ctx: &CmdContext) -> Vec<Box<dyn Effect>> {execute261,8856
+pub struct EnterEditAtCursorCmd {EnterEditAtCursorCmd295,10299
+    pub target_mode: AppMode,target_mode296,10333
+impl Cmd for EnterEditAtCursorCmd {EnterEditAtCursorCmd298,10365
+    fn name(&self) -> &'static str {name299,10401
+    fn execute(&self, _ctx: &CmdContext) -> Vec<Box<dyn Effect>> {execute302,10475
+pub struct EnterExportPrompt;EnterExportPrompt311,10711
+impl Cmd for EnterExportPrompt {EnterExportPrompt312,10741
+    fn name(&self) -> &'static str {name313,10774
+    fn execute(&self, _ctx: &CmdContext) -> Vec<Box<dyn Effect>> {execute316,10847
+pub struct EnterSearchMode;EnterSearchMode323,11023
+impl Cmd for EnterSearchMode {EnterSearchMode324,11051
+    fn name(&self) -> &'static str {name325,11082
+    fn execute(&self, _ctx: &CmdContext) -> Vec<Box<dyn Effect>> {execute328,11142
+pub struct EnterTileSelect;EnterTileSelect338,11399
+impl Cmd for EnterTileSelect {EnterTileSelect339,11427
+    fn name(&self) -> &'static str {name340,11458
+    fn execute(&self, ctx: &CmdContext) -> Vec<Box<dyn Effect>> {execute343,11529
 
-src/command/keymap.rs,5088
+src/command/keymap.rs,5093
 fn format_key_label(code: &KeyCode) -> String {format_key_label13,301
 pub enum KeyPattern {KeyPattern38,1303
     Key(KeyCode, KeyModifiers),Key40,1359
@@ -1904,29 +1908,29 @@ impl KeymapSet {KeymapSet289,9804
     pub fn dispatch(dispatch306,10224
     pub fn dispatch_transient(dispatch_transient318,10642
     pub fn default_keymaps() -> Self {default_keymaps329,10948
-mod tests {tests930,33396
-    fn lookup_exact_match() {lookup_exact_match936,33587
-    fn lookup_exact_with_ctrl() {lookup_exact_with_ctrl944,33877
-    fn lookup_char_falls_back_to_none_mods() {lookup_char_falls_back_to_none_mods952,34175
-    fn lookup_non_char_does_not_fall_back_to_none_mods() {lookup_non_char_does_not_fall_back_to_none_mods962,34633
-    fn lookup_char_falls_to_any_char() {lookup_char_falls_to_any_char972,35046
-    fn lookup_non_char_skips_any_char() {lookup_non_char_skips_any_char986,35414
-    fn lookup_any_matches_everything() {lookup_any_matches_everything995,35722
-    fn lookup_exact_takes_priority_over_any_char() {lookup_exact_takes_priority_over_any_char1009,36067
-    fn lookup_any_char_takes_priority_over_any() {lookup_any_char_takes_priority_over_any1024,36509
-    fn lookup_non_char_falls_to_any_not_any_char() {lookup_non_char_falls_to_any_not_any_char1039,36921
-    fn lookup_ctrl_char_with_only_none_binding_falls_through() {lookup_ctrl_char_with_only_none_binding_falls_through1054,37330
-    fn mode_key_normal_no_search() {mode_key_normal_no_search1065,37836
-    fn mode_key_normal_with_search_overrides() {mode_key_normal_with_search_overrides1071,38005
-    fn mode_key_help() {mode_key_help1077,38189
-    fn mode_key_quit_returns_none() {mode_key_quit_returns_none1083,38342
-    fn lookup_returns_prefix_binding() {lookup_returns_prefix_binding1091,38669
-    fn lookup_returns_sequence_binding() {lookup_returns_sequence_binding1100,39000
-    fn default_keymaps_has_all_modes() {default_keymaps_has_all_modes1114,39551
-    fn normal_mode_has_basic_movement() {normal_mode_has_basic_movement1144,40436
-    fn editing_mode_has_any_char_and_esc() {editing_mode_has_any_char_and_esc1168,41220
-    fn search_mode_has_any_char_and_esc() {search_mode_has_any_char_and_esc1182,41696
-    fn import_wizard_has_any_catchall() {import_wizard_has_any_catchall1194,42090
+mod tests {tests978,34976
+    fn lookup_exact_match() {lookup_exact_match984,35167
+    fn lookup_exact_with_ctrl() {lookup_exact_with_ctrl992,35457
+    fn lookup_char_falls_back_to_none_mods() {lookup_char_falls_back_to_none_mods1000,35755
+    fn lookup_non_char_does_not_fall_back_to_none_mods() {lookup_non_char_does_not_fall_back_to_none_mods1010,36213
+    fn lookup_char_falls_to_any_char() {lookup_char_falls_to_any_char1020,36626
+    fn lookup_non_char_skips_any_char() {lookup_non_char_skips_any_char1034,36994
+    fn lookup_any_matches_everything() {lookup_any_matches_everything1043,37302
+    fn lookup_exact_takes_priority_over_any_char() {lookup_exact_takes_priority_over_any_char1057,37647
+    fn lookup_any_char_takes_priority_over_any() {lookup_any_char_takes_priority_over_any1072,38089
+    fn lookup_non_char_falls_to_any_not_any_char() {lookup_non_char_falls_to_any_not_any_char1087,38501
+    fn lookup_ctrl_char_with_only_none_binding_falls_through() {lookup_ctrl_char_with_only_none_binding_falls_through1102,38910
+    fn mode_key_normal_no_search() {mode_key_normal_no_search1113,39416
+    fn mode_key_normal_with_search_overrides() {mode_key_normal_with_search_overrides1119,39585
+    fn mode_key_help() {mode_key_help1125,39769
+    fn mode_key_quit_returns_none() {mode_key_quit_returns_none1131,39922
+    fn lookup_returns_prefix_binding() {lookup_returns_prefix_binding1139,40249
+    fn lookup_returns_sequence_binding() {lookup_returns_sequence_binding1148,40580
+    fn default_keymaps_has_all_modes() {default_keymaps_has_all_modes1162,41131
+    fn normal_mode_has_basic_movement() {normal_mode_has_basic_movement1192,42016
+    fn editing_mode_has_any_char_and_esc() {editing_mode_has_any_char_and_esc1216,42800
+    fn search_mode_has_any_char_and_esc() {search_mode_has_any_char_and_esc1230,43276
+    fn import_wizard_has_any_catchall() {import_wizard_has_any_catchall1242,43670
 
 src/command/mod.rs,80
 pub mod cmd;cmd8,323
diff --git a/scripts/gen_roadmap.py b/scripts/gen_roadmap.py
new file mode 100755
index 0000000..f7cc3cd
--- /dev/null
+++ b/scripts/gen_roadmap.py
@@ -0,0 +1,179 @@
+#!/usr/bin/env python3
+"""Generate roadmap.org from bd.
+
+Inverted-tree layout: each tree is rooted at an issue that nothing else
+(among the open set) depends on — the "epic" or standalone goal. Its
+children are the things blocking it, recursively. Diamonds in the DAG
+are broken into a tree by duplicating shared deps under each parent so
+emacs `[/]` cookies count whole subtrees.
+
+Usage: python3 scripts/gen_roadmap.py [output-path]
+       (default output: roadmap.org at the repo root)
+"""
+import json
+import re
+import subprocess
+import sys
+from collections import defaultdict
+from pathlib import Path
+
+
+def bd_json(*args):
+    """Run `bd <args>` and parse JSON from stdout."""
+    cmd = ['bd', *args, '--json']
+    res = subprocess.run(cmd, check=True, capture_output=True, text=True)
+    return json.loads(res.stdout)
+
+
+def main():
+    repo = Path(__file__).resolve().parent.parent
+    out_path = Path(sys.argv[1]) if len(sys.argv) > 1 else repo / 'roadmap.org'
+
+    issues = bd_json('list')
+    by_id = {i['id']: i for i in issues}
+    # `bd list --all` includes closed issues — used only to resolve titles
+    # of already-done dep targets so we can label them in :DONE_DEPS:.
+    all_issues = bd_json('list', '--all')
+    all_by_id = {i['id']: i for i in all_issues}
+
+    # --- Build dep graph (open-issue subgraph only) ----------------------
+    # child depends_on parent; in our inverted tree, parent (the goal/epic)
+    # sits ABOVE its deps (children).
+    tree_children = defaultdict(set)
+    tree_parents = defaultdict(set)
+    for i in issues:
+        iid = i['id']
+        for d in (i.get('dependencies') or []):
+            dep = d['depends_on_id']
+            if dep in by_id and iid in by_id:
+                tree_children[iid].add(dep)
+                tree_parents[dep].add(iid)
+
+    def order_key(iid):
+        i = by_id[iid]
+        return (
+            0 if i['status'] == 'in_progress' else 1,
+            i['priority'],
+            iid,
+        )
+
+    roots = sorted(
+        [iid for iid in by_id if not tree_parents.get(iid)],
+        key=order_key,
+    )
+
+    # --- Helpers ---------------------------------------------------------
+    status_kw = {
+        'open': 'TODO',
+        'in_progress': 'DOING',
+        'closed': 'DONE',
+        'blocked': 'WAIT',
+        'deferred': 'WAIT',
+    }
+
+    def tag(s):
+        return re.sub(r'[^A-Za-z0-9_@#%]', '_', s)
+
+    def headline_tags(i, kind):
+        tags = [kind, f"P{i['priority']}", tag(i['issue_type'])]
+        if i.get('assignee'):
+            tags.append('@' + tag(i['assignee']))
+        return ':' + ':'.join(tags) + ':'
+
+    def fmt_date(s):
+        return s.replace('T', ' ').rstrip('Z') if s else ''
+
+    def kind_of(iid):
+        return 'epic' if tree_children.get(iid) else 'standalone'
+
+    out = []
+    out.append('#+TITLE: Improvise Roadmap')
+    out.append('#+AUTHOR: Edward Langley')
+    out.append('#+TODO: TODO DOING WAIT | DONE')
+    out.append('#+STARTUP: overview')
+    out.append('#+TAGS: epic standalone P0 P1 P2 P3 P4 task feature bug')
+    out.append('#+PROPERTY: COOKIE_DATA todo recursive')
+    out.append('')
+    out.append(
+        f'Generated from ~bd list --json~. {len(issues)} open issues '
+        f'organised as {len(roots)} inverted dep-trees: each root is a goal '
+        'that nothing else depends on; its children are the deps blocking '
+        'it. Diamonds in the DAG are duplicated so each tree stands alone.'
+    )
+    out.append('')
+
+    def emit(iid, depth, path):
+        i = by_id[iid]
+        kind = kind_of(iid)
+        kw = status_kw.get(i['status'], 'TODO')
+        title = i['title'].replace('[', '(').replace(']', ')')
+        stars = '*' * depth
+        cookie = ' [/]' if tree_children.get(iid) else ''
+        head = f'{stars} {kw} {title} ({kind}){cookie}'
+        pad = max(1, 95 - len(head))
+        out.append(f'{head}{" " * pad}{headline_tags(i, kind)}')
+
+        indent = '  ' * (depth - 1) + ' '
+        out.append(f'{indent}:PROPERTIES:')
+        out.append(f'{indent}:ID:         {iid}')
+        out.append(f'{indent}:TYPE:       {i["issue_type"]}')
+        out.append(f'{indent}:PRIORITY:   P{i["priority"]}')
+        out.append(f'{indent}:STATUS:     {i["status"]}')
+        if i.get('assignee'):
+            out.append(f'{indent}:ASSIGNEE:   {i["assignee"]}')
+        if i.get('owner'):
+            out.append(f'{indent}:OWNER:      {i["owner"]}')
+        if i.get('created_by'):
+            out.append(f'{indent}:CREATED_BY: {i["created_by"]}')
+        out.append(f'{indent}:CREATED:    {fmt_date(i["created_at"])}')
+        out.append(f'{indent}:UPDATED:    {fmt_date(i["updated_at"])}')
+        if i.get('comment_count'):
+            out.append(f'{indent}:COMMENTS:   {i["comment_count"]}')
+        out.append(f'{indent}:KIND:       {kind}')
+        closed_deps = sorted(
+            d['depends_on_id']
+            for d in (i.get('dependencies') or [])
+            if (ref := all_by_id.get(d['depends_on_id'])) and ref['status'] == 'closed'
+        )
+        if closed_deps:
+            out.append(f'{indent}:DONE_DEPS:  {", ".join(closed_deps)}')
+        if iid in path:
+            out.append(f'{indent}:CYCLE:      yes — descendants pruned at this node')
+        out.append(f'{indent}:END:')
+
+        if iid in path:
+            return  # cycle guard
+
+        details_stars = '*' * (depth + 1)
+        section_stars = '*' * (depth + 2)
+        section_indent = '  ' * (depth + 1) + ' '
+        if any(i.get(k) for k in ('description', 'design', 'acceptance_criteria', 'notes')):
+            out.append(f'{details_stars} Details')
+            for label, key in [
+                ('Description', 'description'),
+                ('Design', 'design'),
+                ('Acceptance Criteria', 'acceptance_criteria'),
+                ('Notes', 'notes'),
+            ]:
+                v = i.get(key)
+                if not v:
+                    continue
+                out.append(f'{section_stars} {label}')
+                for line in v.rstrip('\n').splitlines():
+                    out.append(f'{section_indent}{line}' if line else '')
+
+        new_path = path | {iid}
+        for c in sorted(tree_children.get(iid, set()), key=order_key):
+            out.append('')
+            emit(c, depth + 1, new_path)
+
+    for r in roots:
+        emit(r, 1, frozenset())
+        out.append('')
+
+    out_path.write_text('\n'.join(out))
+    print(f'Wrote {out_path} ({len(out)} lines, {len(roots)} roots, {len(by_id)} issues)')
+
+
+if __name__ == '__main__':
+    main()
diff --git a/src/command/cmd/commit.rs b/src/command/cmd/commit.rs
index 1b166cf..69ad10a 100644
--- a/src/command/cmd/commit.rs
+++ b/src/command/cmd/commit.rs
@@ -118,6 +118,35 @@ mod tests {
         assert!(effects.is_empty());
     }
 
+    /// `CommitAndAdvance` must thread its `edit_mode` through to the
+    /// trailing `EnterEditAtCursor` effect so the post-commit re-edit lands
+    /// in the mode the keymap requested. The command never reads ctx.mode.
+    #[test]
+    fn commit_and_advance_threads_edit_mode_to_enter_edit_at_cursor() {
+        let m = two_cat_model();
+        let layout = make_layout(&m);
+        let reg = make_registry();
+        let mut bufs = HashMap::new();
+        bufs.insert("edit".to_string(), "42".to_string());
+        let mut ctx = make_ctx(&m, &layout, &reg);
+        ctx.buffers = &bufs;
+        // ctx.mode stays Normal — the command must not look at it.
+        let key = ctx.cell_key().unwrap();
+        let cmd = CommitAndAdvance {
+            key,
+            value: "42".to_string(),
+            advance: super::AdvanceDir::Down,
+            cursor: super::CursorState::from_ctx(&ctx),
+            edit_mode: AppMode::records_editing(),
+        };
+        let effects = cmd.execute(&ctx);
+        let dbg = effects_debug(&effects);
+        assert!(
+            dbg.contains("EnterEditAtCursor") && dbg.contains("RecordsEditing"),
+            "Expected trailing EnterEditAtCursor with RecordsEditing target, got: {dbg}"
+        );
+    }
+
     #[test]
     fn commit_export_produces_export_and_normal_mode() {
         let m = two_cat_model();
@@ -234,12 +263,18 @@ pub enum AdvanceDir {
 
 /// Commit a cell edit, advance the cursor, and re-enter edit mode.
 /// Subsumes the old `CommitCellEdit` (Down) and `CommitAndAdvanceRight` (Right).
+///
+/// `edit_mode` is the editing mode to re-enter after advancing. The keymap
+/// binding supplies this — the editing-mode keymap passes `editing` and the
+/// records-editing keymap passes `records-editing`. The command itself
+/// never inspects `ctx.mode`.
 #[derive(Debug)]
 pub struct CommitAndAdvance {
     pub key: CellKey,
     pub value: String,
     pub advance: AdvanceDir,
     pub cursor: CursorState,
+    pub edit_mode: AppMode,
 }
 impl Cmd for CommitAndAdvance {
     fn name(&self) -> &'static str {
@@ -287,7 +322,9 @@ impl Cmd for CommitAndAdvance {
                 }
             }
         }
-        effects.push(Box::new(effect::EnterEditAtCursor));
+        effects.push(Box::new(effect::EnterEditAtCursor {
+            target_mode: self.edit_mode.clone(),
+        }));
         effects
     }
 }
diff --git a/src/command/cmd/mode.rs b/src/command/cmd/mode.rs
index 4c900b0..c2f7245 100644
--- a/src/command/cmd/mode.rs
+++ b/src/command/cmd/mode.rs
@@ -10,21 +10,6 @@ mod tests {
     use crate::command::cmd::test_helpers::*;
     use crate::workbook::Workbook;
 
-    #[test]
-    fn enter_edit_mode_produces_editing_mode() {
-        let m = two_cat_model();
-        let layout = make_layout(&m);
-        let reg = make_registry();
-        let ctx = make_ctx(&m, &layout, &reg);
-        let cmd = EnterEditMode {
-            initial_value: String::new(),
-        };
-        let effects = cmd.execute(&ctx);
-        assert_eq!(effects.len(), 2);
-        let dbg = format!("{:?}", effects[1]);
-        assert!(dbg.contains("Editing"), "Expected Editing mode, got: {dbg}");
-    }
-
     #[test]
     fn enter_tile_select_with_categories() {
         let m = two_cat_model();
@@ -98,11 +83,80 @@ mod tests {
         let layout = make_layout(&m);
         let reg = make_registry();
         let ctx = make_ctx(&m, &layout, &reg);
-        let effects = EditOrDrill.execute(&ctx);
+        let effects = EditOrDrill {
+            edit_mode: AppMode::editing(),
+        }
+        .execute(&ctx);
+        assert_eq!(effects.len(), 2);
         let dbg = effects_debug(&effects);
         assert!(dbg.contains("Editing"), "Expected Editing mode, got: {dbg}");
     }
 
+    /// EditOrDrill must trust its `edit_mode` parameter rather than checking
+    /// `ctx.mode` — the records-normal keymap supplies `records-editing`,
+    /// but the command itself never inspects the runtime mode. This is the
+    /// parallel of the (deleted) `enter_edit_mode_produces_editing_mode`
+    /// test for the records branch.
+    #[test]
+    fn edit_or_drill_passes_records_editing_mode_through() {
+        let m = two_cat_model();
+        let layout = make_layout(&m);
+        let reg = make_registry();
+        // Note: ctx.mode is still Normal here — the command must not look at it.
+        let ctx = make_ctx(&m, &layout, &reg);
+        let effects = EditOrDrill {
+            edit_mode: AppMode::records_editing(),
+        }
+        .execute(&ctx);
+        assert_eq!(effects.len(), 2);
+        let dbg = effects_debug(&effects);
+        assert!(
+            dbg.contains("RecordsEditing"),
+            "Expected RecordsEditing mode, got: {dbg}"
+        );
+    }
+
+    /// `EnterEditAtCursorCmd` must hand its `target_mode` straight through
+    /// to the `EnterEditAtCursor` effect — the keymap (records `o` sequence
+    /// or commit-and-advance) decides; the command never inspects ctx.
+    #[test]
+    fn enter_edit_at_cursor_cmd_passes_target_mode_to_effect() {
+        let m = two_cat_model();
+        let layout = make_layout(&m);
+        let reg = make_registry();
+        let ctx = make_ctx(&m, &layout, &reg);
+        let effects = EnterEditAtCursorCmd {
+            target_mode: AppMode::records_editing(),
+        }
+        .execute(&ctx);
+        assert_eq!(effects.len(), 1);
+        let dbg = format!("{:?}", effects[0]);
+        assert!(
+            dbg.contains("RecordsEditing"),
+            "Expected RecordsEditing target_mode, got: {dbg}"
+        );
+    }
+
+    /// The edit branch pre-fills the `edit` buffer with the cell's current
+    /// display value so the user can modify rather than retype.
+    #[test]
+    fn edit_or_drill_pre_fills_edit_buffer_with_display_value() {
+        let m = two_cat_model();
+        let layout = make_layout(&m);
+        let reg = make_registry();
+        let mut ctx = make_ctx(&m, &layout, &reg);
+        ctx.display_value = "42".to_string();
+        let effects = EditOrDrill {
+            edit_mode: AppMode::editing(),
+        }
+        .execute(&ctx);
+        let dbg = effects_debug(&effects);
+        assert!(
+            dbg.contains("SetBuffer") && dbg.contains("\"edit\"") && dbg.contains("\"42\""),
+            "Expected SetBuffer(\"edit\", \"42\"), got: {dbg}"
+        );
+    }
+
     #[test]
     fn enter_search_mode_sets_flag_and_clears_query() {
         let m = two_cat_model();
@@ -188,36 +242,18 @@ impl Cmd for SaveAndQuit {
 
 // ── Editing entry ───────────────────────────────────────────────────────
 
-/// Enter editing mode with an initial buffer value.
-#[derive(Debug)]
-pub struct EnterEditMode {
-    pub initial_value: String,
-}
-impl Cmd for EnterEditMode {
-    fn name(&self) -> &'static str {
-        "enter-edit-mode"
-    }
-    fn execute(&self, ctx: &CmdContext) -> Vec<Box<dyn Effect>> {
-        let edit_mode = if ctx.mode.is_records() {
-            AppMode::records_editing()
-        } else {
-            AppMode::editing()
-        };
-        vec![
-            Box::new(effect::SetBuffer {
-                name: "edit".to_string(),
-                value: self.initial_value.clone(),
-            }),
-            effect::change_mode(edit_mode),
-        ]
-    }
-}
-
 /// Smart dispatch for i/a: if the cursor is on an aggregated pivot cell
-/// (categories on `Axis::None`, no records mode), drill into it instead of
-/// editing. Otherwise enter edit mode with the current displayed value.
+/// (categories on `Axis::None` and the cell is not a synthetic records-mode
+/// row), drill into it instead of editing. Otherwise pre-fill the edit
+/// buffer with the displayed cell value and enter `edit_mode`.
+///
+/// `edit_mode` is supplied by the keymap binding — the command itself is
+/// mode-agnostic, so the records-normal keymap passes `records-editing`
+/// while the normal keymap passes `editing`.
 #[derive(Debug)]
-pub struct EditOrDrill;
+pub struct EditOrDrill {
+    pub edit_mode: AppMode,
+}
 impl Cmd for EditOrDrill {
     fn name(&self) -> &'static str {
         "edit-or-drill"
@@ -232,7 +268,8 @@ impl Cmd for EditOrDrill {
                 .map(|cat| cat.kind.is_regular())
                 .unwrap_or(false)
         });
-        // In records mode (synthetic key), always edit directly — no drilling.
+        // Synthetic records-mode cells are never aggregated — edit directly.
+        // (This is a layout property, not a mode flag.)
         let is_synthetic = ctx.synthetic_record_at_cursor().is_some();
         let is_aggregated = !is_synthetic && regular_none;
         if is_aggregated {
@@ -241,23 +278,31 @@ impl Cmd for EditOrDrill {
             };
             return DrillIntoCell { key }.execute(ctx);
         }
-        EnterEditMode {
-            initial_value: ctx.display_value.clone(),
-        }
-        .execute(ctx)
+        vec![
+            Box::new(effect::SetBuffer {
+                name: "edit".to_string(),
+                value: ctx.display_value.clone(),
+            }),
+            effect::change_mode(self.edit_mode.clone()),
+        ]
     }
 }
 
 /// Thin command wrapper around the `EnterEditAtCursor` effect so it can
-/// participate in `Binding::Sequence`.
+/// participate in `Binding::Sequence`. `target_mode` is supplied as the
+/// command argument by the keymap binding.
 #[derive(Debug)]
-pub struct EnterEditAtCursorCmd;
+pub struct EnterEditAtCursorCmd {
+    pub target_mode: AppMode,
+}
 impl Cmd for EnterEditAtCursorCmd {
     fn name(&self) -> &'static str {
         "enter-edit-at-cursor"
     }
     fn execute(&self, _ctx: &CmdContext) -> Vec<Box<dyn Effect>> {
-        vec![Box::new(effect::EnterEditAtCursor)]
+        vec![Box::new(effect::EnterEditAtCursor {
+            target_mode: self.target_mode.clone(),
+        })]
     }
 }
 
